#include <avr/io.h>
#include <util/delay.h>

//poarta pe PD5(OCR1A) intre 2000+offset si 1999-offset
//mana pe PD4(OCR1B) intre 1200+offset si 1999-offset


void set_pwm() {

	TCCR1A |= (1 << WGM11) | (1 << COM1A1) | (1 << COM1B1);
	TCCR1B |= (1 << WGM12) | (1 << WGM13) | (1 << CS11);

	ICR1 = 39999;

	OCR1A = 1999 - 800;
	OCR1B = 1799 - 800;
}

void set_pins() {
	DDRD |= 1 << PIND5;
	DDRD |= 1 << PIND4;
	
	DDRD &= ~(1 << PD0);

	PORTD |= (1 << PD0);
}



void routine1() {
	int offset = 800;

	while(1) {
		//open door
		OCR1A = 2000 + offset;
		_delay_ms(700);

		//open hand
		OCR1B = 1200 + offset;
		_delay_ms(300);

		if ((PIND & (1 << PD0)) == 0) {
			continue;
		}

		//close hand
		OCR1B = 1799 - offset;

		if ((PIND & (1 << PD0)) == 0) {
			continue;
		}
		_delay_ms(700);

		//close door
		OCR1A = 1999 - offset;

		break;
	}

}

void routine2() {
	int offset = 800;

	//open door
	OCR1A = 2000 + offset;
	_delay_ms(1200);

	//close door
	OCR1A = 1999 - offset;
	_delay_ms(1000);

	//open door
	OCR1A = 2000 + offset;
	_delay_ms(100);

	//use hand
	OCR1B = 1200 + offset;
	_delay_ms(200);

	//retract hand
	OCR1B = 1799 - offset;
	_delay_ms(200);

	//close door
	OCR1A = 1999 - offset;

}

void routine3() {

	int offset = 800;

	OCR1A = 2000 + offset;
	_delay_ms(700);

	//open hand slowly
	for(int i = 0; i < 1000;i+=10) {
		OCR1B = i + offset;
		_delay_ms(20);
	}

	_delay_ms(500);

	//press switch
	OCR1B = 1200 + offset;

	_delay_ms(2000);

	//close hand
	OCR1B = 1799 - offset;
	_delay_ms(700);

	//close door
	OCR1A = 1999 - offset;

}

void routine4() {
	int offset = 800;

	while(1) {
		//open door
		OCR1A = 2000 + offset;
		_delay_ms(100);

		//open hand
		OCR1B = 1200 + offset;
		_delay_ms(50);

		if ((PIND & (1 << PD0)) == 0) {
			continue;
		}

		//close hand
		OCR1B = 1799 - offset;

		if ((PIND & (1 << PD0)) == 0) {
			continue;
		}
		_delay_ms(100);

		//close door
		OCR1A = 1999 - offset;

		break;
	}
}

int main(void) {

	set_pins();
	set_pwm();
	int count = 0;
	while(1) {


		if ((PIND & (1 << PD0)) == 0) {
			if(count == 0)
				routine1();
			else if(count == 1)
				routine2();
			else if(count == 2)
				routine3();
			else if(count == 3)
				routine4();

			count++;
			count = count % 4;
			continue;
		}

	}

	return 0;
}